// On average, this manages 7.5 iterations per second, on an array of
// 198*320 = 63360 cells.

#include "pvga.h"
#include <iostream.h>
extern "C" {
void     delay    (unsigned);
int      rand     (void);
void     srand    (unsigned);
long     time     (long*);
long     coreleft (void);
unsigned *malloc  (unsigned);
void     free     (unsigned*);
void     exit     (int);
}
inline int random (int __num) { return (int) (((long) rand() * __num)
   / (0x7fffu+1)); }

#define l 10000

void main (void) {
  long it=0, tm=time(0);
  unsigned i, x[l];
  int c=0, mx[l], my[l];

  gogfx; kbsetup; srand ((unsigned) time(0));
  for (i=0; i<64; i++) {
    pal(i,    63-i,   i,   0);
    pal(i+ 64,   i,63-i,   i);
    pal(i+128,  63,   i,63-i);
    pal(i+192,  63,63-i,   0);
  } pal(    0,   0,   0,   0);

  for (i=0; i<l; i++) {
    x[i]=random(198)*320 + random(318) + 321;
    if (rand() & 1) mx[i]=  1; else mx[i]=-  1;
    if (rand() & 1) my[i]=320; else my[i]=-320;
  }

  while (!keydown[1]) {
    c=(c%255)+1; it++;
    for (i=0; i<l; i++) {
      screen[x[i]]=0;
      x[i]+=mx[i]+my[i];
      if (x[i]<320 || x[i]>63680) {
        my[i]=-my[i];
        if (x[i]%320==0 || x[i]%320==319) mx[i]=-mx[i];
      } else if (x[i]%320==0 || x[i]%320==319) mx[i]=-mx[i];
      else if (screen[x[i]]) {
        mx[i] = -mx[i]; my[i] = -my[i];
      }
      screen[x[i]]=(c+i)%255;
    }
  }
  gotxt; kbrestore; free(x);
  tm=time(0)-tm;
  cout << "Bounce: " << it << " iterations in " << tm << " seconds.\n";
}