/*** Game of Life ***

  C++:    198*320=63360 cells,  7.5 its/sec = 475200 calc/sec (100.00%)
  QBasic:  38* 21=  798 cells, 34.0 its/sec =  27132 calc/sec (  5.88%)

	O.     OO                                   OO     OO      OO
   .   .**     *O   OOO         O+    OO      OO   O  O   O  O    O  O
  *O*   **.  O*       O   OO   O O   O  O   O  O   O O    O  O   O  O
   .    .O   OO      O    OO   +O     OO    OO      O      OO     OO

 Blink  b2   bc0   Glide  c0  c1(+)   c2     c2b    c3     c4     c4b
				Circles can be chained in rows!
       OOO
      O  O                      OOOO    OOOOO    OOOOOO
      O O                       O   O   O    O   O     O
      O O                       O       O        O         Horizontal
     O  O                        O       O        O        Glider 1-3
     OOO    S-Shape

  */

//#include "pvga.h"
extern "C" {
int  rand     (void);
void srand    (unsigned);
long time     (long*);
long coreleft (void);
char *malloc  (unsigned);
void free     (char*);
void exit     (int);
int  printf   (const char*, ...);
}

#include <dos.h>
void gotxt (void) { asm { mov ax, 0x03; int 0x10 } }
void gogfx (void) { asm { mov ax, 0x13; int 0x10 } }
unsigned char keydown[128];
static void interrupt (far *kbold) (...);// = getvect (9);
void interrupt kbnew (...) {
  asm {
    cli;
  } kbn1: asm {
    in  al, 0x60;
    cmp al, 0xe0; jne kbn2;
    mov al, 0x20; out 0x20, al;
    jmp short kbn1;
  } kbn2: asm {
    mov bl, al; and bx, 127;
    and al, 128; xor al, 128; shr al, 7;
    mov bx [keydown], al;
    mov al, 0x20; out 0x20, al;
    sti;
  }
}
void inline kbsetup   (void) { kbold = getvect (9); setvect (9, kbnew); }
void inline kbrestore (void) { setvect (9, kbold); }
unsigned char far* screen =
  (unsigned char far*) ((void _seg*)(0xA000) + (void near*)(0));
#define pal(c,r,g,b) { outp(0x3c8,c);\
  outp(0x3c9, r); outp(0x3c9, g); outp(0x3c9, b); }

void main (void) {
  int n;
  unsigned i, it=0, l=0xfa00; //64000;
  long tm=time(0);
  char *c=malloc (l);
  if (c==0) {
    l=(int)coreleft ();
    c=malloc (l);
    if (c==0) exit (-1);
  } l -=320;
  gogfx (); kbsetup (); srand ((unsigned) time(0));
  for (i=0; i<64; i++) {
    pal(i,    63-i,   i,   0);
    pal(i+ 64,   i,63-i,   i);
    pal(i+128,  63,   i,63-i);
    pal(i+192,  63,63-i,   0);
  } pal(    0,   0,   0,   0);

  for (i=320; i<l; i++) {
    c[i]=rand() & 1;
    screen[i]=0;
  }
  while (!keydown[1]) {
    for (i=320; i<l; i++) {
      n=c[i-321]+c[i-320]+c[i-319]+
	c[i-  1]         +c[i+  1]+
	c[i+319]+c[i+320]+c[i+321];
      if (n==3 || (c[i] !=0 && n==2))
	screen[i]=(screen[i] % 255) + 1;
      else screen[i]=0;
    }
    for (i=320; i<l; i++)
      c[i]=(screen[i] !=0);
    it++;
    while (keydown[25]);
  }
  gotxt (); kbrestore (); free (c);
  tm=time(0)-tm;
  printf ("Life had %d iterations in %d seconds.\n", it, tm);
}
